---
Name: supermicro-install-manager
Description: "Install sum to manage servers in-band"
Documentation: |
  This task assumes that the archive containing the management binaries
  lives on the dr-provision static file server at files/hw_repo.
Templates:
  - Name: "sum-install"
    Contents: |
      #!/usr/bin/env bash
      {{ template "setup.tmpl" . }}
      {{ template "set-proxy-servers.sh.tmpl" .}}
      target="{{.Param "supermicro-manager-install-target"}}"
      src="{{.ProvisionerURL}}/files/hw_repo/{{.Param "supermicro-manager-archive"}}"

      printf "Checking SUM tool download access ... "
      status=$(curl -ksLr 0-0 -o /dev/null -w "%{http_code}" "$src")

      if [[ $status -eq 206 ]]; then
        echo "Available at:"
        echo "$src"
      else
        echo ""
        job_error "FAILED"
        skiplist=$(drpcli machines get $RS_UUID param "universal/workflow-chain-map-skip-list" --aggregate | jq -c '. += [ "universal-hardware" ] | unique')
        echo ""
        echo "================================================================================="
        echo "! NOTICE:  Attempted to download SUM tools, which were not available for        !"
        echo "!          download at the specified source (see below).                        !"
        echo "!                                                                               !"
        echo "!          You must obtain the SuperMicro Update manager tool for Hardware      !"
        echo "!          Lifecycle management support of this platform.  That can only be     !"
        echo "!          obtained by contacting SuperMicro directly (*).                      !"
        echo "!                                                                               !"
        echo "!          Once the specified version is obtained; stage it at the URL on the   !"
        echo "!          DRP Endpoint as defined in the Param 'supermicro-manager-archive'.   !"
        echo "!                                                                               !"
        echo "!          If you do NOT have access to the tool; you must either skip the      !"
        echo "!          'universal-hardware' workflow or specific tasks that try to use the  !"
        echo "!          tool.  See the Params 'universal/workflow-chain-map-skip-list' or    !"
        echo "!          'task-skip' for more detail on how to skip workflows or tasks (**).  !"
        echo "================================================================================="
        echo ""
        echo "*  SUM download site:  https://www.supermicro.com/en/solutions/management-software/supermicro-update-manager"
        echo ""
        echo "** Potential skip 'universal-hardware' procedure (note, no BIOS, Firmware, or RAID will be completed):"
        echo ""
        echo "     drpcli machines set $RS_UUID param universal/workflow-chain-map-skip-list to '$skiplist'"
        echo ""
        echo "   only changes current machine, must restart workflow to skip current universal-hardware"
        echo ""
        job_error "Unable to download '$src'"
        exit 1
      fi

      [[ -d $target ]] || mkdir -p "$target"
      [[ -d /opt/bin ]] || mkdir -p /opt/bin
      [[ -x /opt/bin/sum ]] && exit 0
      cd "$target"
      curl -fgL "$src" -o sum.tgz
      tar xzf sum.tgz
      rm sum.tgz
      mv sum*/* .
      mv sum /opt/bin

      job_success "SUM tool successfully made available on Machine."
